package lancs.midp.mobilephoto.optional.copyPhoto.handler;

import javax.microedition.lcdui.Command;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreNotOpenException;

import ubc.midp.mobilephoto.core.ui.controller.PhotoController;
import ubc.midp.mobilephoto.core.ui.datamodel.ImageAccessor;
import ubc.midp.mobilephoto.core.ui.datamodel.ImageData;
import ubc.midp.mobilephoto.core.ui.screens.PhotoViewScreen;
import ubc.midp.mobilephoto.core.util.ImageUtil;
import lancs.midp.mobilephoto.optional.copyPhoto.PhotoViewController;
import lancs.midp.mobilephoto.optional.copyPhoto.events.*;
import lancs.midp.ptolemy.exceptionblocks.dataModelAspectEH.events.*;
import edu.iastate.cs.ptolemy.runtime.*;

@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
@PrecedesHandler(lancs.midp.mobilephoto.optional.favourites.handler.FavoriteEventHandler.class)
public class CopyPhotoHandler {

	public CopyPhotoHandler() { register(this); }

	/* [EF] Added in scenario 05 */
	public static final Command copyCommand = new Command("Copy", Command.ITEM, 1);
	
	public void ImageAccessor.addImageData(String photoname, ImageData imageData, String albumname) throws RecordStoreException {
		try {
			imageRS = RecordStore.openRecordStore(ALBUM_LABEL + albumname, true);
			imageInfoRS = RecordStore.openRecordStore(INFO_LABEL + albumname, true);
			int rid2; // new record ID for ImageData (metadata)
			ImageUtil converter = new ImageUtil();
			rid2 = imageInfoRS.getNextRecordID();
			imageData.setRecordId(rid2);
			byte[] data1 = converter.getBytesFromImageInfo(imageData).getBytes();
			imageInfoRS.addRecord(data1, 0, data1.length);
		} catch (RecordStoreException e) {
			throw new PersistenceMechanismException();
		}finally{
			try {
				imageRS.closeRecordStore();
				imageInfoRS.closeRecordStore();
			} catch (RecordStoreNotOpenException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (RecordStoreException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public void handler(SetPhotoScreenEvent next)throws Throwable {
		PhotoViewController control = new PhotoViewController(next.controller.midlet, next.controller.getAlbumData(), next.controller.getAlbumListScreen(), next.imageName);
		control.setNextController(next.controller);
	
		invoke(next);
	}
	when SetPhotoScreenEvent do handler;

	public void handler(PhotoViewScreenCreatedEvent next) throws Throwable {
		invoke(next);
		
		next.f.addCommand(CopyPhotoHandler.copyCommand);
	}
	when PhotoViewScreenCreatedEvent do handler;
}
