package lancs.midp.mobilephoto.optional.sorting.CountViewAspect.handler;

import java.util.Hashtable;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;

import ubc.midp.mobilephoto.core.ui.datamodel.*;
import ubc.midp.mobilephoto.core.util.*;
import lancs.midp.mobilephoto.lib.exceptions.ImageNotFoundException;
import lancs.midp.mobilephoto.optional.sorting.CountViewAspect.events.*;
import lancs.midp.ptolemy.exceptionblocks.controllerAspectEH.events.*;
import lancs.midp.ptolemy.exceptionblocks.utilAspectEH.events.*;
import lancs.midp.mobilephoto.alternative.photo.*;
import edu.iastate.cs.ptolemy.runtime.*;

@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
@PrecedesHandler(lancs.midp.mobilephoto.optional.favourites.handler.PersisteFavoritesEventHandler.class)
public class CountViewEventHandler {
	
	
	public static boolean sort = false;
	public static final Command sortCommand = new Command("Sort by Views", Command.ITEM, 1);
		
	// [EF] Added in the scenario 02 
	private int MediaData.numberOfViews = 0;
	
	/**
	 * [EF] Added in the scenario 02 
	 */
	public void MediaData.increaseNumberOfViews() {
		this.numberOfViews++;
	}

	/**
	 * [EF] Added in the scenario 02 
	 * @return the numberOfViews
	 */
	public int MediaData.getNumberOfViews() {
		return numberOfViews;
	}
	
	/**
	 * [EF] Added in the scenario 02 
	 * @param views
	 */
	public void MediaData.setNumberOfViews(int views) {
		this.numberOfViews = views;
	}
	
	public CountViewEventHandler() {
		register(this);
	}

	public void handler(ShowImageEvent next) throws Throwable {
		invoke(next);
		
		MediaData image = next.album.getMediaAccessor().getMediaInfo(next.selectedImageName);
		image.setNumberOfViews(new Integer(image.getNumberOfViews()+1));
		next.album.getMediaAccessor().updateMediaInfo(image, image);
			System.out.println("<* BaseController.handleCommand() *> Image = "+next.selectedImageName+ "; # views = "
					+image.getNumberOfViews());
	}
	
	when ShowImageEvent do handler;

	public void handler(InitMenuEvent next)throws Throwable{
		invoke(next);
		next.screen.addCommand(CountViewEventHandler.sortCommand);
	}
	
	when InitMenuEvent do handler;	

	public String handler(GetBytesFromImageInfoEvent next) throws Throwable {
		String byteString = invoke(next);
		
		// [EF] Added in scenatio 02
		byteString = byteString.concat(MediaUtil.DELIMITER);
		byteString = byteString.concat("" + next.ii.getNumberOfViews());
		
		return byteString;
	}
	
	when GetBytesFromImageInfoEvent do handler;


	public MediaData handler(CreateImageDataEvent next) throws Throwable {

		int endIndex = next.endIndex;
		int startIndex = endIndex + 1;
		endIndex = next.iiString.indexOf(MediaUtil.DELIMITER, startIndex);
		
		if (endIndex == -1)
			endIndex = next.iiString.length();
		
		// [EF] Added in the scenario 02 
		int numberOfViews = 0;
		try {
			numberOfViews = Integer.parseInt(next.iiString.substring(startIndex, endIndex));
		} catch (RuntimeException e) {
			numberOfViews = 0;
			e.printStackTrace();
		}
		
		MediaData imageData = invoke(next);
		
		imageData.setNumberOfViews(new Integer(numberOfViews));

		return imageData;
	}
	
	when CreateImageDataEvent do handler;

	public boolean handler(CommandActionEvent next)throws Throwable
	{ 
		boolean handled = invoke(next);
		
		if (handled) return true;
		
		String label = next.c.getLabel();
		System.out.println("<* CountViewsAspect.around handleCommandAction *> ::handleCommand: " + label);
		
		/** Case: Sort photos by number of views
		 * [EF] Added in the scenario 02 **/
		if (label.equals("Sort by Views")) {
			// TODO set sort = true
			sort = true;
			next.controller.showMediaList(next.controller.getCurrentStoreName());
			next.controller.setCurrentStoreName(Constants.IMAGELIST_SCREEN);
			return true;
		}
		return false;
	}
	
	when CommandActionEvent do handler;

	public void handler(AppendImagesEvent next) throws Throwable{
		
		if (CountViewEventHandler.sort) {
			bubbleSort(next.images);
		}
		CountViewEventHandler.sort = false;
		
		invoke(next);
	}

	private void bubbleSort(MediaData[] images) {
		System.out.print("Sorting by BubbleSort...");		
		for (int end = images.length; end > 1; end --) {
			for (int current = 0; current < end - 1; current ++) {
				if (images[current].getNumberOfViews() > images[current+1].getNumberOfViews()) {
					exchange(images, current, current+1);
				}
			}
		}
		System.out.println("done.");
	}
	private void exchange(MediaData[] images, int pos1, int pos2) {
		MediaData tmp = images[pos1];
		images[pos1] = images[pos2];
		images[pos2] = tmp;
	}

	
	when AppendImagesEvent do handler;

	

	
}
