package lancs.midp.mobilephoto.optional.sms.handler;

import java.util.HashMap;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Image;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;

import ubc.midp.mobilephoto.core.ui.datamodel.MediaAccessor;
import ubc.midp.mobilephoto.core.ui.datamodel.MediaData;
import ubc.midp.mobilephoto.core.ui.screens.AddMediaToAlbum;
import lancs.midp.mobilephoto.alternative.photo.PhotoViewScreen;
import ubc.midp.mobilephoto.core.util.MediaUtil;

import lancs.midp.mobilephoto.lib.exceptions.InvalidImageDataException;
import lancs.midp.mobilephoto.lib.exceptions.PersistenceMechanismException;
import lancs.midp.ptolemy.exceptionblocks.dataModelAspectEH.events.*;
import lancs.midp.mobilephoto.optional.copyPhoto.events.*;

import lancs.midp.mobilephoto.optional.sms.events.*;
import ubc.midp.mobilephoto.sms.*;
import ubc.midp.mobilephoto.core.ui.controller.*;
import ubc.midp.mobilephoto.core.ui.screens.*;
import ubc.midp.mobilephoto.core.ui.datamodel.*;
import lancs.midp.mobilephoto.alternative.photo.handler.PhotoAspectHandler;
import lancs.midp.mobilephoto.alternative.photo.ImageMediaAccessor;
import edu.iastate.cs.ptolemy.runtime.*;

@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
@PrecedesHandler(lancs.midp.mobilephoto.optional.copyPhoto.handler.CopyPhotoHandler.class)
public class SMSAspectHandler {
	public static final Command smscopyCommand = new Command("Send Photo by SMS", Command.ITEM, 1);

	private boolean PhotoViewScreen.fromSMS = false;
	
	public boolean PhotoViewScreen.isFromSMS(){
		return fromSMS;
	}
	
	public void PhotoViewScreen.setFromSMS(boolean fromSMS){
		this.fromSMS = fromSMS;
	}

	public SMSAspectHandler() { register(this); }

	public void handler(StartApplicationEvent next)throws Throwable{
		invoke(next);
		BaseController imageRootController = PhotoAspectHandler.imageRootController;
		AlbumData imageModel = PhotoAspectHandler.imageModel;
		
		AlbumListScreen albumListScreen = (AlbumListScreen)imageRootController.getAlbumListScreen(); // [EF]
		SmsReceiverController controller = new SmsReceiverController(next.middlet, imageModel, albumListScreen);
		controller.setNextController(imageRootController);
		SmsReceiverThread smsR = new SmsReceiverThread(next.middlet, imageModel, albumListScreen, controller);
		System.out.println("SmsController::Starting SMSReceiver Thread");
		new Thread(smsR).start();
	}
	when StartApplicationEvent do handler;

	public void handler(PhotoViewScreenCreatedEvent next)throws Throwable{
		invoke(next);
		next.f.addCommand(SMSAspectHandler.smscopyCommand);
	}
	when PhotoViewScreenCreatedEvent do handler;

	public void handler(LoadImageEvent next)throws Throwable{
		if (next.screen.isFromSMS()){
		   return;
		}
		else 
		{
		   invoke(next);
		}
	}
	when LoadImageEvent do handler;

	public void handler(GetPhotoControllerEvent next)throws Throwable{
		invoke(next);
		SmsSenderController smscontroller = new SmsSenderController(next.controller.midlet, next.controller.getAlbumData(), 
					(AlbumListScreen)next.controller.getAlbumListScreen(), next.imageName);
		smscontroller.setNextController(next.controller);
		return;
	}
	when GetPhotoControllerEvent do handler;
}
